Index: /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Manipulators/PWRInsertionManipulator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Manipulators/PWRInsertionManipulator.cs	(revision 8886)
+++ /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Manipulators/PWRInsertionManipulator.cs	(revision 8887)
@@ -28,5 +28,4 @@
 
 namespace HeuristicLab.Encodings.ScheduleEncoding.PermutationWithRepetition {
-
   [Item("PWRInsertionManipulator", "Represents a manipulation operation inserting parts of the individual at another position.")]
   [StorableClass]
@@ -34,11 +33,10 @@
     [StorableConstructor]
     protected PWRInsertionManipulator(bool deserializing) : base(deserializing) { }
-    protected PWRInsertionManipulator(PWRInsertionManipulator original, Cloner cloner)
-      : base(original, cloner) {
-    }
+    protected PWRInsertionManipulator(PWRInsertionManipulator original, Cloner cloner) : base(original, cloner) { }
+    public PWRInsertionManipulator() : base() { }
+
     public override IDeepCloneable Clone(Cloner cloner) {
       return new PWRInsertionManipulator(this, cloner);
     }
-    public PWRInsertionManipulator() : base() { }
 
     public static void Apply(IRandom random, PWREncoding individual) {
Index: /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Manipulators/PWRManipulator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Manipulators/PWRManipulator.cs	(revision 8886)
+++ /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Manipulators/PWRManipulator.cs	(revision 8887)
@@ -20,4 +20,5 @@
 #endregion
 
+using System;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
@@ -27,5 +28,6 @@
   [Item("PWRManipulator", "An operator which manipulates a PWR representation.")]
   [StorableClass]
-  public abstract class PWRManipulator : ScheduleManipulator<PWREncoding>, IPWROperator {
+  public abstract class PWRManipulator : ScheduleManipulator, IPWROperator {
+
     [StorableConstructor]
     protected PWRManipulator(bool deserializing) : base(deserializing) { }
@@ -38,7 +40,7 @@
     protected abstract void Manipulate(IRandom random, PWREncoding individual);
 
-
     public override IOperation Apply() {
-      PWREncoding solution = ScheduleEncodingParameter.ActualValue;
+      var solution = ScheduleEncodingParameter.ActualValue as PWREncoding;
+      if (solution == null) throw new InvalidOperationException("ScheduleEncoding was not found or is not of type PWREncoding.");
       Manipulate(RandomParameter.ActualValue, solution);
       return base.Apply();
Index: /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/PWRRandomCreator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/PWRRandomCreator.cs	(revision 8886)
+++ /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/PWRRandomCreator.cs	(revision 8887)
@@ -30,8 +30,5 @@
   [Item("PermutationWithRepetitionRandomCreator", "Creates PWR-individuals at random.")]
   [StorableClass]
-  public class PWRRandomCreator : ScheduleCreator<PWREncoding>, IStochasticOperator {
-    public IRandom Random {
-      get { return RandomParameter.ActualValue; }
-    }
+  public class PWRRandomCreator : ScheduleCreator, IStochasticOperator {
 
     public ILookupParameter<IRandom> RandomParameter {
@@ -47,11 +44,5 @@
     [StorableConstructor]
     protected PWRRandomCreator(bool deserializing) : base(deserializing) { }
-    protected PWRRandomCreator(PWRRandomCreator original, Cloner cloner)
-      : base(original, cloner) {
-    }
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new PWRRandomCreator(this, cloner);
-    }
-
+    protected PWRRandomCreator(PWRRandomCreator original, Cloner cloner) : base(original, cloner) { }
     public PWRRandomCreator()
       : base() {
@@ -63,11 +54,14 @@
     }
 
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new PWRRandomCreator(this, cloner);
+    }
+
     public static PWREncoding Apply(int jobs, int resources, IRandom random) {
       return new PWREncoding(jobs, resources, random);
     }
 
-
-    protected override PWREncoding CreateSolution() {
-      return Apply(JobsParameter.ActualValue.Value, ResourcesParameter.ActualValue.Value, Random);
+    protected override IScheduleEncoding CreateSolution() {
+      return Apply(JobsParameter.ActualValue.Value, ResourcesParameter.ActualValue.Value, RandomParameter.ActualValue);
     }
   }
Index: /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/Plugin.cs.frame
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/Plugin.cs.frame	(revision 8886)
+++ /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/Plugin.cs.frame	(revision 8887)
@@ -23,5 +23,5 @@
 
 namespace HeuristicLab.Encodings.ScheduleEncoding {
-  [Plugin("HeuristicLab.Encodings.ScheduleEncoding", "3.3.3.$WCREV$")]
+  [Plugin("HeuristicLab.Encodings.ScheduleEncoding", "3.3.7.$WCREV$")]
   [PluginFile("HeuristicLab.Encodings.ScheduleEncoding-3.3.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Collections", "3.3")]
Index: /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Crossovers/PRVCrossover.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Crossovers/PRVCrossover.cs	(revision 8886)
+++ /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Crossovers/PRVCrossover.cs	(revision 8887)
@@ -27,5 +27,6 @@
   [Item("PRVCrossover", "An operator which crosses two PRV representations.")]
   [StorableClass]
-  public abstract class PRVCrossover : ScheduleCrossover<PRVEncoding>, IPRVOperator {
+  public abstract class PRVCrossover : ScheduleCrossover, IPRVOperator {
+
     [StorableConstructor]
     protected PRVCrossover(bool deserializing) : base(deserializing) { }
@@ -37,9 +38,8 @@
     }
 
-
     public abstract PRVEncoding Cross(IRandom random, PRVEncoding parent1, PRVEncoding parent2);
 
     public override IOperation Apply() {
-      ItemArray<PRVEncoding> parents = ParentsParameter.ActualValue;
+      var parents = ParentsParameter.ActualValue;
       ChildParameter.ActualValue =
         Cross(RandomParameter.ActualValue, parents[0] as PRVEncoding, parents[1] as PRVEncoding);
Index: /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Crossovers/PRVDiscreteCrossover.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Crossovers/PRVDiscreteCrossover.cs	(revision 8886)
+++ /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Crossovers/PRVDiscreteCrossover.cs	(revision 8887)
@@ -29,18 +29,18 @@
   [StorableClass]
   public class PRVDiscreteCrossover : PRVCrossover {
+
     [StorableConstructor]
     protected PRVDiscreteCrossover(bool deserializing) : base(deserializing) { }
-    protected PRVDiscreteCrossover(PRVDiscreteCrossover original, Cloner cloner)
-      : base(original, cloner) {
-    }
+    protected PRVDiscreteCrossover(PRVDiscreteCrossover original, Cloner cloner) : base(original, cloner) { }
+    public PRVDiscreteCrossover() : base() { }
+
     public override IDeepCloneable Clone(Cloner cloner) {
       return new PRVDiscreteCrossover(this, cloner);
     }
-    public PRVDiscreteCrossover() : base() { }
-
 
     public static PRVEncoding Apply(IRandom random, PRVEncoding parent1, PRVEncoding parent2) {
       return new PRVEncoding(DiscreteCrossover.Apply(random, new ItemArray<IntegerVector>(new IntegerVector[] { parent1.PriorityRulesVector, parent2.PriorityRulesVector })), parent1.NrOfRules);
     }
+
     public override PRVEncoding Cross(IRandom random, PRVEncoding parent1, PRVEncoding parent2) {
       return Apply(random, parent1, parent2);
Index: /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Crossovers/PRVSinglePointCrossover.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Crossovers/PRVSinglePointCrossover.cs	(revision 8886)
+++ /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Crossovers/PRVSinglePointCrossover.cs	(revision 8887)
@@ -29,13 +29,13 @@
   [StorableClass]
   public class PRVSinglePointCrossover : PRVCrossover {
+
     [StorableConstructor]
     protected PRVSinglePointCrossover(bool deserializing) : base(deserializing) { }
-    protected PRVSinglePointCrossover(PRVSinglePointCrossover original, Cloner cloner)
-      : base(original, cloner) {
-    }
+    protected PRVSinglePointCrossover(PRVSinglePointCrossover original, Cloner cloner) : base(original, cloner) { }
+    public PRVSinglePointCrossover() : base() { }
+
     public override IDeepCloneable Clone(Cloner cloner) {
       return new PRVSinglePointCrossover(this, cloner);
     }
-    public PRVSinglePointCrossover() : base() { }
 
     public static PRVEncoding Apply(IRandom random, PRVEncoding parent1, PRVEncoding parent2) {
Index: /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Manipulators/PRVManipulator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Manipulators/PRVManipulator.cs	(revision 8886)
+++ /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Manipulators/PRVManipulator.cs	(revision 8887)
@@ -20,4 +20,5 @@
 #endregion
 
+using System;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
@@ -27,5 +28,5 @@
   [Item("PRVManipulator", "An operator which manipulates a PRV representation.")]
   [StorableClass]
-  public abstract class PRVManipulator : ScheduleManipulator<PRVEncoding>, IPRVOperator {
+  public abstract class PRVManipulator : ScheduleManipulator, IPRVOperator {
     [StorableConstructor]
     protected PRVManipulator(bool deserializing) : base(deserializing) { }
@@ -36,8 +37,9 @@
     }
 
+    protected abstract void Manipulate(IRandom random, PRVEncoding individual);
 
-    protected abstract void Manipulate(IRandom random, PRVEncoding individual);
     public override IOperation Apply() {
-      PRVEncoding solution = ScheduleEncodingParameter.ActualValue;
+      var solution = ScheduleEncodingParameter.ActualValue as PRVEncoding;
+      if (solution == null) throw new InvalidOperationException("ScheduleEncoding was not found or is not of type PRVEncoding.");
       Manipulate(RandomParameter.ActualValue, solution);
       return base.Apply();
Index: /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Manipulators/PRVUniformOnePositionManipulator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Manipulators/PRVUniformOnePositionManipulator.cs	(revision 8886)
+++ /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Manipulators/PRVUniformOnePositionManipulator.cs	(revision 8887)
@@ -27,18 +27,16 @@
 
 namespace HeuristicLab.Encodings.ScheduleEncoding.PriorityRulesVector {
-
   [Item("PRVUniformOnePositionManipulator", "Represents a manipulation operation inserting parts of the individual at another position.")]
   [StorableClass]
   public class PRVUniformOnePositionManipulator : PRVManipulator {
+
     [StorableConstructor]
     protected PRVUniformOnePositionManipulator(bool deserializing) : base(deserializing) { }
-    protected PRVUniformOnePositionManipulator(PRVUniformOnePositionManipulator original, Cloner cloner)
-      : base(original, cloner) {
-    }
+    protected PRVUniformOnePositionManipulator(PRVUniformOnePositionManipulator original, Cloner cloner) : base(original, cloner) { }
+    public PRVUniformOnePositionManipulator() : base() { }
+
     public override IDeepCloneable Clone(Cloner cloner) {
       return new PRVUniformOnePositionManipulator(this, cloner);
     }
-    public PRVUniformOnePositionManipulator() : base() { }
-
 
     public static void Apply(IRandom random, PRVEncoding individual) {
Index: /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/PRVRandomCreator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/PRVRandomCreator.cs	(revision 8886)
+++ /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/PRVRandomCreator.cs	(revision 8887)
@@ -27,9 +27,9 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-
 namespace HeuristicLab.Encodings.ScheduleEncoding.PriorityRulesVector {
   [Item("PriorityRulesRandomCreator", "Creator class used to create PRV encoding objects for scheduling problems.")]
   [StorableClass]
-  public class PRVRandomCreator : ScheduleCreator<PRVEncoding>, IStochasticOperator {
+  public class PRVRandomCreator : ScheduleCreator, IStochasticOperator {
+
     [Storable]
     public IntValue NrOfRules { get; set; }
@@ -45,5 +45,4 @@
     }
 
-
     [StorableConstructor]
     protected PRVRandomCreator(bool deserializing) : base(deserializing) { }
@@ -51,7 +50,4 @@
       : base(original, cloner) {
       this.NrOfRules = cloner.Clone(original.NrOfRules);
-    }
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new PRVRandomCreator(this, cloner);
     }
     public PRVRandomCreator()
@@ -64,9 +60,13 @@
     }
 
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new PRVRandomCreator(this, cloner);
+    }
+
     public static PRVEncoding Apply(int jobs, int resources, IRandom random, IntValue nrOfRules) {
       return new PRVEncoding(jobs * resources, random, 0, nrOfRules.Value, nrOfRules);
     }
 
-    protected override PRVEncoding CreateSolution() {
+    protected override IScheduleEncoding CreateSolution() {
       return Apply(JobsParameter.ActualValue.Value, ResourcesParameter.ActualValue.Value, RandomParameter.ActualValue, NrOfRules);
     }
Index: /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/Properties/AssemblyInfo.cs.frame
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/Properties/AssemblyInfo.cs.frame	(revision 8886)
+++ /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/Properties/AssemblyInfo.cs.frame	(revision 8887)
@@ -1,5 +1,5 @@
 #region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -55,3 +55,3 @@
 // [assembly: AssemblyVersion("1.0.*")]
 [assembly: AssemblyVersion("3.3.0.0")]
-[assembly: AssemblyFileVersion("3.3.3.$WCREV$")]
+[assembly: AssemblyFileVersion("3.3.7.$WCREV$")]
Index: /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleCreator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleCreator.cs	(revision 8886)
+++ /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleCreator.cs	(revision 8887)
@@ -29,20 +29,17 @@
   [Item("ScheduleCreator", "Represents the generalized form of creators for Scheduling Problems.")]
   [StorableClass]
-  public abstract class ScheduleCreator<T> : SingleSuccessorOperator, IScheduleCreator where T : Item {
-    public ILookupParameter<T> ScheduleEncodingParameter {
-      get { return (ILookupParameter<T>)Parameters["ScheduleEncoding"]; }
+  public abstract class ScheduleCreator : SingleSuccessorOperator, IScheduleCreator {
+
+    public ILookupParameter<IScheduleEncoding> ScheduleEncodingParameter {
+      get { return (ILookupParameter<IScheduleEncoding>)Parameters["ScheduleEncoding"]; }
     }
-
 
     [StorableConstructor]
     protected ScheduleCreator(bool deserializing) : base(deserializing) { }
-    protected ScheduleCreator(ScheduleCreator<T> original, Cloner cloner)
-      : base(original, cloner) {
-    }
+    protected ScheduleCreator(ScheduleCreator original, Cloner cloner) : base(original, cloner) { }
     public ScheduleCreator()
       : base() {
-      Parameters.Add(new LookupParameter<T>("ScheduleEncoding", "The new scheduling solutioncandidate."));
+      Parameters.Add(new LookupParameter<IScheduleEncoding>("ScheduleEncoding", "The new scheduling solutioncandidate."));
     }
-
 
     public override IOperation Apply() {
@@ -50,5 +47,6 @@
       return base.Apply();
     }
-    protected abstract T CreateSolution();
+
+    protected abstract IScheduleEncoding CreateSolution();
   }
 }
Index: /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleCrossover.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleCrossover.cs	(revision 8886)
+++ /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleCrossover.cs	(revision 8887)
@@ -30,15 +30,12 @@
   [Item("ScheduleCrossover", "A scheduling crossover operation.")]
   [StorableClass]
-  public abstract class ScheduleCrossover<T> : SingleSuccessorOperator, IScheduleCrossover, IStochasticOperator where T : Item {
-    #region IScheduleCrossover Members
-    public ILookupParameter<ItemArray<T>> ParentsParameter {
-      get { return (ScopeTreeLookupParameter<T>)Parameters["Parents"]; }
+  public abstract class ScheduleCrossover : SingleSuccessorOperator, IScheduleCrossover, IStochasticOperator {
+
+    public ILookupParameter<IScheduleEncoding> ChildParameter {
+      get { return (ILookupParameter<IScheduleEncoding>)Parameters["Child"]; }
     }
-
-    public ILookupParameter<T> ChildParameter {
-      get { return (ILookupParameter<T>)Parameters["Child"]; }
+    public IScopeTreeLookupParameter<IScheduleEncoding> ParentsParameter {
+      get { return (IScopeTreeLookupParameter<IScheduleEncoding>)Parameters["Parents"]; }
     }
-    #endregion
-
     public ILookupParameter<IRandom> RandomParameter {
       get { return (LookupParameter<IRandom>)Parameters["Random"]; }
@@ -47,14 +44,12 @@
     [StorableConstructor]
     protected ScheduleCrossover(bool deserializing) : base(deserializing) { }
-    protected ScheduleCrossover(ScheduleCrossover<T> original, Cloner cloner)
-      : base(original, cloner) {
-    }
+    protected ScheduleCrossover(ScheduleCrossover original, Cloner cloner) : base(original, cloner) { }
     public ScheduleCrossover()
       : base() {
       Parameters.Add(new LookupParameter<IRandom>("Random", "The pseudo random number generator which should be used for stochastic manipulation operators."));
-      Parameters.Add(new ScopeTreeLookupParameter<T>("Parents", "The parent solution which should be crossed."));
+      Parameters.Add(new LookupParameter<IScheduleEncoding>("Child", "The child solution resulting from the crossover."));
+      ChildParameter.ActualName = "SchedulingSolution";
+      Parameters.Add(new ScopeTreeLookupParameter<IScheduleEncoding>("Parents", "The parent solution which should be crossed."));
       ParentsParameter.ActualName = "SchedulingSolution";
-      Parameters.Add(new LookupParameter<T>("Child", "The child solution resulting from the crossover."));
-      ChildParameter.ActualName = "SchedulingSolution";
     }
   }
Index: /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding/Crossovers/DirectScheduleCrossover.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding/Crossovers/DirectScheduleCrossover.cs	(revision 8886)
+++ /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding/Crossovers/DirectScheduleCrossover.cs	(revision 8887)
@@ -28,5 +28,5 @@
   [Item("DirectScheduleCrossover", "An operator which crosses two schedule representations.")]
   [StorableClass]
-  public abstract class DirectScheduleCrossover : ScheduleCrossover<Schedule>, IDirectScheduleOperator {
+  public abstract class DirectScheduleCrossover : ScheduleCrossover, IDirectScheduleOperator {
     [StorableConstructor]
     protected DirectScheduleCrossover(bool deserializing) : base(deserializing) { }
@@ -39,5 +39,4 @@
     }
 
-
     public ILookupParameter<ItemList<Job>> JobDataParameter {
       get { return (LookupParameter<ItemList<Job>>)Parameters["JobData"]; }
@@ -47,5 +46,5 @@
 
     public override IOperation Apply() {
-      ItemArray<Schedule> parents = ParentsParameter.ActualValue;
+      var parents = ParentsParameter.ActualValue;
       ChildParameter.ActualValue =
         Cross(RandomParameter.ActualValue, parents[0] as Schedule, parents[1] as Schedule);
Index: /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding/Crossovers/DirectScheduleGTCrossover.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding/Crossovers/DirectScheduleGTCrossover.cs	(revision 8886)
+++ /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding/Crossovers/DirectScheduleGTCrossover.cs	(revision 8887)
@@ -30,26 +30,23 @@
   [StorableClass]
   public class DirectScheduleGTCrossover : DirectScheduleCrossover {
+
+    public IValueLookupParameter<DoubleValue> MutationProbabilityParameter {
+      get { return (IValueLookupParameter<DoubleValue>)Parameters["MutationProbability"]; }
+    }
+
     [StorableConstructor]
     protected DirectScheduleGTCrossover(bool deserializing) : base(deserializing) { }
-    protected DirectScheduleGTCrossover(DirectScheduleGTCrossover original, Cloner cloner)
-      : base(original, cloner) {
+    protected DirectScheduleGTCrossover(DirectScheduleGTCrossover original, Cloner cloner) : base(original, cloner) { }
+    public DirectScheduleGTCrossover()
+      : base() {
+      Parameters.Add(new ValueLookupParameter<DoubleValue>("MutationProbability", "The probability that a task from the conflict set is chosen randomly instead of from one of the parents."));
     }
+
     public override IDeepCloneable Clone(Cloner cloner) {
       return new DirectScheduleGTCrossover(this, cloner);
     }
-    public DirectScheduleGTCrossover()
-      : base() {
-      Parameters.Add(new LookupParameter<PercentValue>("MutationProbability", "The probability that the mutation operator is applied on a solution."));
-    }
-
-
-    private LookupParameter<PercentValue> MutationProbabilityParameter {
-      get { return (LookupParameter<PercentValue>)Parameters["MutationProbability"]; }
-    }
-
 
     public static Schedule Apply(IRandom random, Schedule parent1, Schedule parent2, ItemList<Job> jobData, double mutProp) {
-      Schedule child = new Schedule(parent1.Resources.Count);
-
+      var child = new Schedule(parent1.Resources.Count);
 
       //Reset scheduled tasks in result
@@ -75,5 +72,5 @@
         int progressOnResource = conflictedResource.Tasks.Count;
         Task selectedTask = null;
-        if (random.Next(100) < mutProp) {
+        if (random.NextDouble() < mutProp) {
           //Mutation
           selectedTask = conflictSet[random.Next(conflictSet.Count)];
@@ -95,5 +92,4 @@
     }
 
-
     private static Task SelectTaskFromConflictSet(ItemList<Task> conflictSet, Schedule usedParent, int conflictedResourceNr, int progressOnResource) {
       //Apply Crossover
@@ -109,6 +105,6 @@
 
     public override Schedule Cross(IRandom random, Schedule parent1, Schedule parent2) {
-      ItemList<Job> jobData = (ItemList<Job>)JobDataParameter.ActualValue.Clone();
-      PercentValue mutProp = MutationProbabilityParameter.ActualValue;
+      var jobData = (ItemList<Job>)JobDataParameter.ActualValue.Clone();
+      var mutProp = MutationProbabilityParameter.ActualValue;
       return Apply(random, parent1, parent2, jobData, mutProp.Value);
     }
Index: /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding/DirectScheduleRandomCreator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding/DirectScheduleRandomCreator.cs	(revision 8886)
+++ /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding/DirectScheduleRandomCreator.cs	(revision 8887)
@@ -33,5 +33,5 @@
   [Item("DirectScheduleRandomCreator", "Creator class used to create schedule encoding objects.")]
   [StorableClass]
-  public class DirectScheduleRandomCreator : ScheduleCreator<Schedule>, IStochasticOperator {
+  public class DirectScheduleRandomCreator : ScheduleCreator, IStochasticOperator {
 
     public ILookupParameter<IRandom> RandomParameter {
@@ -68,5 +68,5 @@
 
     public static Schedule Apply(int jobs, int resources, PWREncoding pwr, ItemList<Job> jobData) {
-      Schedule resultingSchedule = new Schedule(jobData[0].Tasks.Count);
+      var resultingSchedule = new Schedule(jobData[0].Tasks.Count);
       foreach (int jobNr in pwr.PermutationWithRepetition) {
         int i = 0;
@@ -82,13 +82,12 @@
 
 
-    protected override Schedule CreateSolution() {
+    protected override IScheduleEncoding CreateSolution() {
       try {
-        ItemList<Job> jobData = (ItemList<Job>)JobDataParameter.ActualValue.Clone();
+        var jobData = (ItemList<Job>)JobDataParameter.ActualValue.Clone();
         return Apply(JobsParameter.ActualValue.Value,
           ResourcesParameter.ActualValue.Value,
           new PWREncoding(JobsParameter.ActualValue.Value, ResourcesParameter.ActualValue.Value, RandomParameter.ActualValue),
           jobData);
-      }
-      catch {
+      } catch {
         throw new Exception("ScheduleRandomCreator needs JobData parameter from a JSSP-Instance to create Schedule-Instances!");
       }
Index: /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding/Job.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding/Job.cs	(revision 8886)
+++ /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding/Job.cs	(revision 8887)
@@ -30,5 +30,7 @@
   [StorableClass]
   public class Job : Item, INotifyPropertyChanged {
-    [Storable(Name = "DueDate")] private double dueDate;
+
+    [Storable(Name = "DueDate")]
+    private double dueDate;
     public double DueDate {
       get { return dueDate; }
@@ -52,5 +54,5 @@
 
     [Storable(Name = "Tasks")]
-    private ItemList<Task> tasks; 
+    private ItemList<Task> tasks;
     public ItemList<Task> Tasks {
       get { return tasks; }
@@ -70,7 +72,5 @@
       this.Tasks = cloner.Clone(original.Tasks);
     }
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new Job(this, cloner);
-    }
+    public Job() : this(-1, double.MaxValue) { }
     public Job(int index, double dueDate)
       : base() {
@@ -78,4 +78,8 @@
       Index = index;
       Tasks = new ItemList<Task>();
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new Job(this, cloner);
     }
 
Index: /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding/Manipulators/DirectScheduleManipulator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding/Manipulators/DirectScheduleManipulator.cs	(revision 8886)
+++ /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding/Manipulators/DirectScheduleManipulator.cs	(revision 8887)
@@ -20,4 +20,5 @@
 #endregion
 
+using System;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
@@ -27,5 +28,6 @@
   [Item("DirectScheduleManipulator", "An operator which manipulates a direct schedule representation.")]
   [StorableClass]
-  public abstract class DirectScheduleManipulator : ScheduleManipulator<Schedule>, IDirectScheduleOperator {
+  public abstract class DirectScheduleManipulator : ScheduleManipulator, IDirectScheduleOperator {
+
     [StorableConstructor]
     protected DirectScheduleManipulator(bool deserializing) : base(deserializing) { }
@@ -36,9 +38,10 @@
     }
 
+    protected abstract void Manipulate(IRandom random, Schedule individual);
 
-    protected abstract void Manipulate(IRandom random, Schedule individual);
     public override IOperation Apply() {
-      Schedule solution = ScheduleEncodingParameter.ActualValue;
-      Manipulate(RandomParameter.ActualValue, solution);
+      var schedule = ScheduleEncodingParameter.ActualValue as Schedule;
+      if (schedule == null) throw new InvalidOperationException("ScheduleEncoding was not found or is not of type Schedule.");
+      Manipulate(RandomParameter.ActualValue, schedule);
       return base.Apply();
     }
Index: /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding/Task.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding/Task.cs	(revision 8886)
+++ /trunk/sources/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding/Task.cs	(revision 8887)
@@ -30,4 +30,5 @@
   [StorableClass]
   public class Task : Item, INotifyPropertyChanged {
+
     [Storable(Name = "TaskNr")]
     private int taskNr;
@@ -94,9 +95,5 @@
       this.IsScheduled = original.IsScheduled;
     }
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new Task(this, cloner);
-    }
-
-
+    public Task() : this(-1, -1, -1, 0) { }
     public Task(int taskNr, int resNr, int jobNr, double duration)
       : base() {
@@ -106,4 +103,8 @@
       TaskNr = taskNr;
       IsScheduled = false;
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new Task(this, cloner);
     }
 
@@ -120,7 +121,9 @@
         return false;
     }
+
     public override int GetHashCode() {
       return TaskNr ^ JobNr;
     }
+
     public static bool AreEqual(Task task1, Task task2) {
       return (task1.Duration == task2.Duration &&
